# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from .. import utilities, tables

class Container(pulumi.CustomResource):
    container_access_type: pulumi.Output[str]
    """
    The 'interface' for access the container provides. Can be either `blob`, `container` or `private`. Defaults to `private`.
    """
    name: pulumi.Output[str]
    """
    The name of the storage container. Must be unique within the storage service the container is located.
    """
    properties: pulumi.Output[dict]
    """
    Key-value definition of additional properties associated to the storage container
    """
    resource_group_name: pulumi.Output[str]
    """
    The name of the resource group in which to
    create the storage container. Changing this forces a new resource to be created.
    """
    storage_account_name: pulumi.Output[str]
    """
    Specifies the storage account in which to create the storage container.
    Changing this forces a new resource to be created.
    """
    def __init__(__self__, resource_name, opts=None, container_access_type=None, name=None, resource_group_name=None, storage_account_name=None, __name__=None, __opts__=None):
        """
        Manage an Azure Storage Container.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] container_access_type: The 'interface' for access the container provides. Can be either `blob`, `container` or `private`. Defaults to `private`.
        :param pulumi.Input[str] name: The name of the storage container. Must be unique within the storage service the container is located.
        :param pulumi.Input[str] resource_group_name: The name of the resource group in which to
               create the storage container. Changing this forces a new resource to be created.
        :param pulumi.Input[str] storage_account_name: Specifies the storage account in which to create the storage container.
               Changing this forces a new resource to be created.

        > This content is derived from https://github.com/terraform-providers/terraform-provider-azurerm/blob/master/website/docs/r/storage_container.html.markdown.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['container_access_type'] = container_access_type

        __props__['name'] = name

        if resource_group_name is None:
            raise TypeError("Missing required property 'resource_group_name'")
        __props__['resource_group_name'] = resource_group_name

        if storage_account_name is None:
            raise TypeError("Missing required property 'storage_account_name'")
        __props__['storage_account_name'] = storage_account_name

        __props__['properties'] = None

        super(Container, __self__).__init__(
            'azure:storage/container:Container',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

